#!/bin/bash

LANGUAGES=( en de fr ) # just examples has to be extended...

get_params() {
	echo "Is this an initial setup? (yes/no)"
	echo -n "# "
	read IS_INITIAL
	echo ""
	echo "Mediawiki Postgres database setup"
	echo ""
	echo "Please enter the name prefix of the wiki database"
	echo -n "# "
	read DATABASE_PREFIX
	echo ""
	echo "Please enter the wiki database user for this wiki"
	echo -n "# "
	read WIKI_DB_USER
	echo ""
	echo "Does this database user already exist? (yes/no)"
	echo -n "# "
	read USER_EXISTS
	echo ""
	echo "Please enter the wiki database user's password"
	echo -n "# "
	read -s WIKI_DB_PASSWORD
	echo ""

	DATABASE_NAME=$DATABASE_PREFIX"_template1"
}

create_db_user() {
	psql -U postgres -c "CREATE ROLE $WIKI_DB_USER WITH PASSWORD '"$WIKI_DB_PASSWORD"'"
}

create_db_template() {
	createdb -U postgres -E UTF8 -T template0 -O $WIKI_DB_USER $DATABASE_NAME
	createlang -U postgres plpgsql $DATABASE_NAME
	psql -U postgres -d $DATABASE_NAME -c "grant select on pg_ts_config to $WIKI_DB_USER;"
	psql -U postgres -d $DATABASE_NAME -c "grant select on pg_ts_config_map to $WIKI_DB_USER;"
	psql -U postgres -d $DATABASE_NAME -c "grant select on pg_ts_dict to $WIKI_DB_USER;"
	psql -U postgres -d $DATABASE_NAME -c "grant select on pg_ts_parser to $WIKI_DB_USER;"
	echo ""
	echo "Your database "$DATABASE_NAME" has be created."
}

copy_template_to_dbs() {
	for i in ${LANGUAGES[@]}; do
		createdb -U postgres -T $DATABASE_NAME $DATABASE_PREFIX"_"$i # language changes maybe have to be done...
		echo ""
		echo "Your database "$DATABASE_PREFIX"_"$i" has be created."
	done
}

get_params

if [ "$USER_EXISTS" = "no" ]; then
	create_db_user
elif [ "$USER_EXISTS" != "yes" ]; then
	echo "Script ended without doing anything since you didn't give all infos..."
	exit
fi

if [ "$IS_INITIAL" = "yes" ]; then
	create_db_template
elif [ "$IS_INITIAL" = "no" ]; then
	copy_template_to_dbs
else
	echo "Script ended without doing anything since you didn't give all infos..."
	exit
fi
